/* 
*
*  ProLinga-Run
*
*  Copyright (C) 2002-2008 Xobas Software.
*  All rights reserved.
*  
*  This file is part of ProLinga-Run.
*
*  ProLinga-Run is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  ProLinga-Run is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with ProLinga-Run.  If not, see <http://www.gnu.org/licenses/>.
*
*  More information is available at the following addresses:
*
*  Website     : http://www.prolinga.org
*
*  Email       : prolinga-list@prolinga.org
*
*/

#include "RunCommon.h"
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include "RepositoryAccess.hpp"

#if BUILD_REPOSITORY
#include <prolinga/Repository.hpp>
extern PlRepositoryPtr repRunPtr;
                                                                                                                                             
xmlDocPtr RepositoryAccess(const xmlDocPtr docReq)
{
	/* Process Request */
	return repRunPtr->executeCommand(docReq);
}
#else
#include <prolinga/SoapClient.hpp>

//extern char *repositoryEndPoint;

xmlDocPtr RepositoryAccess(const xmlDocPtr docReq, const char *repositoryEndPoint, const int repositoryCompressionLevel)
{
	PlSoapClient sclient;

	/* DEBUG */
//	xmlBufferPtr bufReq;
//	xmlNodePtr curReq;
//	bufReq = xmlBufferCreate();
//	curReq = xmlDocGetRootElement(docReq);
//	xmlNodeDump(bufReq, docReq, curReq, 0, 1);
//	printf("\n%s\n", (char *)xmlBufferContent(bufReq));
//	xmlBufferFree(bufReq);


	/* Process Request */
	return sclient.soapCall(docReq, repositoryEndPoint, repositoryCompressionLevel);
}
#endif

