/* 
*
*  ProLinga-Run
*
*  Copyright (C) 2002-2008 Xobas Software.
*  All rights reserved.
*  
*  This file is part of ProLinga-Run.
*
*  ProLinga-Run is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  ProLinga-Run is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with ProLinga-Run.  If not, see <http://www.gnu.org/licenses/>.
*
*  More information is available at the following addresses:
*
*  Website     : http://www.prolinga.org
*
*  Email       : prolinga-list@prolinga.org
*
*
*/

#ifndef __REPOSITORY_COMMAND_HPP
#define __REPOSITORY_COMMAND_HPP

/* Basic rep operations */
xmlDocPtr RC_List(const char *objApplication, const char *objType, const char *objName);
xmlDocPtr RC_Get(const char *objApplication, const char *objType, const char *objName);
xmlDocPtr RC_Put(xmlDocPtr docReq);
xmlDocPtr RC_Delete(const char *objApplication, const char *objType, const char *objName);
xmlDocPtr RC_Ping(const char *objApplication, const char *objType, const char *objName);
xmlDocPtr RC_SysInfo(void);

/* Wrappers basic rep operations */
int repGet(xmlDocPtr *docRes, const char *objAppn, const char *objType, const char *objName);
int repPut(const xmlDocPtr docReq);
int repDelete(const char *objAppn, const char *objType, const char *objName);
int repSysInfoSetting(const char *setting, char *retValue);

/* Read */
int repReadPutDataRef(const xmlDocPtr docRes, const char *recName, const char *tableName, const bool isMainThread);
int repReadPutXmlBuffer(const xmlDocPtr docRes, const xmlDocPtr docDef, const char *tableName);

/* Write */
int repWriteRequestShell(xmlDocPtr *docReq, xmlNodePtr *curReq, const char *appnName, const char *objType, const char *objName);
int repWriteGetDataRef(xmlDocPtr *docReq, xmlNodePtr *curReq, char *recName, const char *tableName, const bool isMainThread);
int repWriteGetXmlBuffer(xmlDocPtr *docReq, xmlNodePtr *curReq, const xmlDocPtr docDef, const char *tableName);

/* Entries */
int repClrEntry(const char *tableName, const char *instance);
int repGetEntry(const char *keyValue, const char *sequenceNo, const char *recName, const char *tableName, bool isMainThread);
int repPutEntry(const char *keyValue, const char *sequenceNo, const char *recName, const char *tableName, bool isMainThread);

#endif /* __REPOSITORY_COMMAND_HPP */
